---
title: ident
slug: Web/CSS/ident
tags:
  - CSS
  - CSS Data Type
  - Data Type
  - Draft
  - Layout
  - Reference
  - Web
  - ident
---
<p>{{CSSRef}}{{Draft}}</p>

<p><span class="seoSummary">The <strong><code>&lt;ident&gt;</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/CSS_Types">data type</a> denotes an arbitrary string used as an {{glossary("identifier")}}.</span></p>

<h2 id="Syntax">Syntax</h2>

<p>The syntax of <code>&lt;custom-ident&gt;</code> is similar to CSS identifiers (such as property names), except that it is <a class="external" href="http://en.wikipedia.org/wiki/Case_sensitivity">case-sensitive</a>. It consists of one or more characters, where characters can be any of the following:</p>

<ul>
 <li>any alphabetical character (<code>A</code> to <code>Z</code>, or <code>a</code> to <code>z</code>),</li>
 <li>any decimal digit (<code>0</code> to <code>9</code>),</li>
 <li>a hyphen (<code>-</code>),</li>
 <li>an underscore (<code>_</code>),</li>
 <li>an escaped character (preceded by a backslash, <code>\</code>),</li>
 <li>a <a class="external" href="http://en.wikipedia.org/wiki/Unicode">Unicode</a> character (in the format of a backslash, <code>\</code>, followed by one to six hexadecimal digits, representing its Unicode code point)</li>
</ul>

<p>Note that <code>id1</code>, <code>Id1</code>, <code>iD1</code> and <code>ID1</code> are all different identifiers as they are <a class="external" href="http://en.wikipedia.org/wiki/Case_sensitivity">case-sensitive</a>. On the other hand, as there are several ways to escape a character, <code>toto\?</code> and <code>toto\3F</code> are the same identifiers.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Valid_identifiers">Valid identifiers</h3>

<pre class="brush: none; no-line-numbers example-good notranslate">nono79      	A mix of alphanumeric characters and numbers
ground-level	A mix of alphanumeric characters and a dash
-test       	A dash followed by alphanumeric characters
--toto      	A custom-property like identifier
_internal   	An underscore followed by alphanumeric characters
\22 toto    	A Unicode character followed by a sequence of alphanumeric characters
bili\.bob   	A correctly escaped period
</pre>

<h3 id="Invalid_identifiers">Invalid identifiers</h3>

<pre class="brush: none; no-line-numbers example-bad notranslate">34rem   	It must not start with a decimal digit.
-12rad  	It must not start with a dash followed by a decimal digit.
bili.bob	Only alphanumeric characters, _, and - needn't be escaped.
'bilibob'	This would be a {{CSSxRef("&lt;string&gt;")}}.
"bilibob"	This would be a {{CSSxRef("&lt;string&gt;")}}.
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Values', '#css-identifier', '<code>&lt;ident&gt;</code>')}}</td>
   <td>{{Spec2('CSS4 Values')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('CSS3 Values', '#css-identifier', '<code>&lt;ident&gt;</code>')}}</td>
   <td>{{Spec2('CSS3 Values')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p><em>As this type is not a real type but a convenience type used to simplify the definition of other CSS syntax.</em></p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{CSSxRef("&lt;custom-ident&gt;")}} – A restricted subset of <code>&lt;ident&gt;</code> values excluding <span style="white-space: nowrap;">CSS-wide</span> keywords, {{CSSxRef("--*", "custom properties")}} and other <span style="white-space: nowrap;">per-property</span> values.</li>
</ul>
